## trurl 0.8

=== Makefile ===
TARGET = trurl
OBJS = trurl.o
LDLIBS = $$(curl-config --libs)
CFLAGS += $$(curl-config --cflags) -W -Wall -Wshadow -Werror -pedantic -g -std=gnu99
MANUAL = trurl.1

PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
MANDIR ?= $(PREFIX)/share/man/man1

INSTALL ?= install
PYTHON3 ?= python3

$(TARGET): $(OBJS)
	$(CC) $(OBJS) -o $(TARGET) $(LDLIBS) $(LDFLAGS)

trurl.o:trurl.c version.h

.PHONY: install
install:
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)
	$(INSTALL) -d $(DESTDIR)$(MANDIR)
	$(INSTALL) -m 0644 $(MANUAL) $(DESTDIR)$(MANDIR)

.PHONY: clean
clean:
	rm -f $(OBJS) $(TARGET)

.PHONY: test
test: $(TARGET)
	@$(PYTHON3) test.py

.PHONY: test-memory
test-memory: $(TARGET)
	@$(PYTHON3) test.py --with-valgrind

.PHONY: checksrc
checksrc:
	./checksrc.pl trurl.c version.h

## trurl 0.4

=== debian/changelog ===
trurl (0.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1034375)

 -- Michael Ablassmeier <abi@debian.org>  Thu, 13 Apr 2023 21:32:08 +0200

=== debian/control ===
Source: trurl
Section: utils
Priority: optional
Maintainer: Michael Ablassmeier <abi@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13), libcurl4-gnutls-dev (>= 7.88.1)
Standards-Version: 4.6.2
Homepage: https://github.com/curl/trurl

Package: trurl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: command line tool for URL parsing and manipulation
 Parses, manipulates and outputs URLs and parts of URLs.
 Typically you pass in one or more URLs and decide what of that you want
 output.  Posssibly modifying the URL as well.
 .
 trurl knows URLs and every URL consists of up to ten separate and independent
 "components". These components can be extracted, removed and updated with
 trurl and they are referred to by their respective names: scheme, user,
 password, options, host, port, path, query, fragment and zoneid.

## trurl 0.6

=== debian/changelog ===
trurl (0.6-1) unstable; urgency=medium

  * New upstream release.
  * Upstream moved tests from perl to python, add required
    build dependencies.
  * Add debian/trurl.docs: ship README and RELEASE-NOTES
  * Add debian/upstream/metadata

 -- Michael Ablassmeier <abi@debian.org>  Sat, 29 Apr 2023 07:57:37 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Michael Ablassmeier <abi@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
- debhelper-compat (= 13), libcurl4-gnutls-dev (>= 7.88.1)
+ debhelper-compat (= 13), libcurl4-gnutls-dev (>= 7.88.1), python3, python3-packaging
 Standards-Version: 4.6.2
 Homepage: https://github.com/curl/trurl

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_install:
	dh_auto_install --destdir=debian/trurl -- PREFIX=/usr

## trurl 0.8

=== debian/changelog ===
trurl (0.8-2) unstable; urgency=medium

  * Modify testcases to be compatible with libcurl 8.3.0 (Closes: #1052828)

 -- Michael Ablassmeier <abi@debian.org>  Wed, 27 Sep 2023 20:16:36 +0200

trurl (0.8-1) unstable; urgency=medium

  [ Carlos Henrique Lima Melara ]
  * Run wrap-and-sort.
  * debian/control:
      - Add Vcs fields to source stanza.
      - Add myself as uploader.
      - Move to web section of the archive.
      - Remove python3-packaging from Build-Depends.
      - Slight rephrase of long description.
  * debian/copyright:
      - Add Upstream-Contact field.
      - Update packaging copyright section.
  * debian/gbp.conf: add basic definitions.
  * debian/rules:
      - Export DEB_BUILD_MAINT_OPTIONS.
      - Simplify rules exporting PREFIX.
  * debian/salsa-ci.yml: use salsa-ci.
  * debian/tests/control: add tests from upstream to autopkgtest.
  * debian/watch: scan via github API.

  [ Michael Ablassmeier ]
  * New upstream version 0.8.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Thu, 22 Jun 2023 09:59:32 -0300

trurl (0.7-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Ablassmeier <abi@debian.org>  Tue, 30 May 2023 21:28:56 +0200

## trurl 0.9

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,27 @@
+##########################################################################
+#                                  _   _ ____  _
+#  Project                     ___| | | |  _ \| |
+#                             / __| | | | |_) | |
+#                            | (__| |_| |  _ <| |___
+#                             \___|\___/|_| \_\_____|
+#
+# Copyright (C) Daniel Stenberg, <daniel@haxx.se>, et al.
+#
+# This software is licensed as described in the file COPYING, which
+# you should have received as part of this distribution. The terms
+# are also available at https://curl.se/docs/copyright.html.
+#
+# You may opt to use, copy, modify, merge, publish, distribute and/or sell
+# copies of the Software, and permit persons to whom the Software is
+# furnished to do so, under the terms of the COPYING file.
+#
+# This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
+# KIND, either express or implied.
+#
+# SPDX-License-Identifier: curl
+#
+##########################################################################
+
 TARGET = trurl
 OBJS = trurl.o
 LDLIBS = $$(curl-config --libs)

=== debian/changelog ===
trurl (0.9-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:28:28 +1100

trurl (0.9-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:28:46 +0000

trurl (0.9-1) unstable; urgency=medium

  * New upstream version 0.9
  * debian/patches/versionfix: upstream forgot to raise version
  prior to release: add patch so executable contains correct
  version.

 -- Michael Ablassmeier <abi@debian.org>  Thu, 02 Nov 2023 12:16:49 +0100

=== debian/control ===
Source: trurl
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Ablassmeier <abi@debian.org>
Uploaders: Carlos Henrique Lima Melara <charlesmelara@riseup.net>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               libcurl4-gnutls-dev (>= 7.88.1),
               python3
Standards-Version: 4.6.2
Homepage: https://github.com/curl/trurl
Vcs-Browser: https://salsa.debian.org/debian/trurl
Vcs-Git: https://salsa.debian.org/debian/trurl.git

Package: trurl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for URL parsing and manipulation
 trurl is a cli tool that parses and manipulates URLs, designed to help shell
 script authors everywhere. Typically you pass in one or more URLs and decide
 what of that you want output. Posssibly modifying the URL as well.
 .
 trurl knows URLs and every URL consists of up to ten separate and independent
 "components". These components can be extracted, removed and updated with
 trurl and they are referred to by their respective names: scheme, user,
 password, options, host, port, path, query, fragment and zoneid.

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|a|b)\d*)$/$1~$2/, \
dversionmangle=s/@DEB_EXT@//, \
repacksuffix=+dfsg" \
https://api.github.com/repos/curl/trurl/releases?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/@PACKAGE@-?@ANY_VERSION@

## trurl 0.12

=== debian/changelog ===
trurl (0.12-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Sun, 05 May 2024 16:21:59 -0300

trurl (0.12-1) unstable; urgency=medium

  [ Michael Ablassmeier ]
  * New upstream version 0.12.
  * New upstream version 0.11.

  [ Carlos Henrique Lima Melara ]
  * debian/upstream/signing-key.asc: add upstream pgp key.
  * debian/watch: use git mode to get and verify signed tags.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Fri, 19 Apr 2024 00:52:23 -0300

trurl (0.10-1) unstable; urgency=medium

  [ Carlos Henrique Lima Melara ]
  * d/copyright: update copyright holders info and years.

  [ Michael Ablassmeier ]
  * New upstream version 0.10.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Wed, 28 Feb 2024 23:30:44 -0300

## trurl 0.13

=== debian/changelog ===
trurl (0.13-1) unstable; urgency=medium

  * New upstream version 0.13

 -- Michael Ablassmeier <abi@debian.org>  Wed, 15 May 2024 13:18:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: trurl
 Section: web
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Michael Ablassmeier <abi@debian.org>
+Maintainer: Michael Ablassmeier <abi@debian.org>
 Uploaders: Carlos Henrique Lima Melara <charlesmelara@riseup.net>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),

## trurl 0.14

=== Makefile ===
--- 
+++ 
@@ -24,8 +24,15 @@
 
 TARGET = trurl
 OBJS = trurl.o
-LDLIBS = $$(curl-config --libs)
-CFLAGS += $$(curl-config --cflags) -W -Wall -Wshadow -Werror -pedantic -g -std=gnu99
+ifndef TRURL_IGNORE_CURL_CONFIG
+LDLIBS += $$(curl-config --libs)
+CFLAGS += $$(curl-config --cflags)
+endif
+CFLAGS += -W -Wall -Wshadow -Werror -pedantic
+CFLAGS += -Wconversion -Wmissing-prototypes -Wwrite-strings -Wsign-compare -Wno-sign-conversion
+ifndef NDEBUG
+CFLAGS += -g
+endif
 MANUAL = trurl.1
 
 PREFIX ?= /usr/local
@@ -36,9 +43,9 @@
 PYTHON3 ?= python3
 
 $(TARGET): $(OBJS)
-	$(CC) $(OBJS) -o $(TARGET) $(LDLIBS) $(LDFLAGS)
+	$(CC) $(OBJS) -o $(TARGET) $(LDFLAGS) $(LDLIBS)
 
-trurl.o:trurl.c version.h
+trurl.o: trurl.c version.h
 
 .PHONY: install
 install:

=== debian/changelog ===
trurl (0.14-1) unstable; urgency=medium

  * New upstream version 0.14
  * Raise standards version to 4.7.0

 -- Michael Ablassmeier <abi@debian.org>  Mon, 29 Jul 2024 21:33:29 +0200

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=gittag" \
https://github.com/curl/trurl.git \
refs/tags/@PACKAGE@@ANY_VERSION@

## trurl 0.15.1

=== debian/changelog ===
trurl (0.15.1-1) unstable; urgency=medium

  [ Michael Ablassmeier ]
  * New upstream version 0.15.1
  * debian/patches: remove patch for manpage
  * debian/watch: use release packages instead of git repo which doesn't
    contain manpage
  * debian/watch: fix version detect

  [ Carlos Henrique Lima Melara ]
  * debian/copyright: update upstream copyright stanza.

 -- Michael Ablassmeier <abi@debian.org>  Sun, 15 Sep 2024 09:15:19 +0200

trurl (0.15-1) UNRELEASED; urgency=medium

  * New upstream version 0.15
  * Add debian/patches/manpage: ship manpage in nroff format

 -- Michael Ablassmeier <abi@debian.org>  Wed, 28 Aug 2024 09:22:36 +0200

## trurl 0.16

=== Makefile ===
--- 
+++ 
@@ -28,10 +28,10 @@
 LDLIBS += $$(curl-config --libs)
 CFLAGS += $$(curl-config --cflags)
 endif
-CFLAGS += -W -Wall -Wshadow -Werror -pedantic
+CFLAGS += -W -Wall -Wshadow -pedantic
 CFLAGS += -Wconversion -Wmissing-prototypes -Wwrite-strings -Wsign-compare -Wno-sign-conversion
 ifndef NDEBUG
-CFLAGS += -g
+CFLAGS += -Werror -g
 endif
 MANUAL = trurl.1
 
@@ -43,7 +43,7 @@
 PYTHON3 ?= python3
 
 $(TARGET): $(OBJS)
-	$(CC) $(OBJS) -o $(TARGET) $(LDFLAGS) $(LDLIBS)
+	$(CC) $(LDFLAGS) $(OBJS) -o $(TARGET) $(LDLIBS)
 
 trurl.o: trurl.c version.h
 
@@ -52,7 +52,9 @@
 	$(INSTALL) -d $(DESTDIR)$(BINDIR)
 	$(INSTALL) -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)
 	$(INSTALL) -d $(DESTDIR)$(MANDIR)
-	$(INSTALL) -m 0644 $(MANUAL) $(DESTDIR)$(MANDIR)
+	(if test -f $(MANUAL); then \
+	$(INSTALL) -m 0644 $(MANUAL) $(DESTDIR)$(MANDIR); \
+	fi)
 
 .PHONY: clean
 clean:

=== debian/changelog ===
trurl (0.16-1) unstable; urgency=medium

  * New upstream version 0.16

 -- Michael Ablassmeier <abi@debian.org>  Thu, 19 Sep 2024 09:44:20 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                libcurl4-gnutls-dev (>= 7.88.1),
                python3
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/curl/trurl
 Vcs-Browser: https://salsa.debian.org/debian/trurl
 Vcs-Git: https://salsa.debian.org/debian/trurl.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX=/usr

%:
	dh $@

## trurl 0.16.1

=== Makefile ===
--- 
+++ 
@@ -38,27 +38,38 @@
 PREFIX ?= /usr/local
 BINDIR ?= $(PREFIX)/bin
 MANDIR ?= $(PREFIX)/share/man/man1
+ZSH_COMPLETIONSDIR ?= $(PREFIX)/share/zsh/site-functions
+COMPLETION_FILES=scripts/_trurl.zsh
 
 INSTALL ?= install
 PYTHON3 ?= python3
+
+all: $(TARGET) $(MANUAL)
 
 $(TARGET): $(OBJS)
 	$(CC) $(LDFLAGS) $(OBJS) -o $(TARGET) $(LDLIBS)
 
 trurl.o: trurl.c version.h
 
+$(MANUAL): trurl.md
+	./scripts/cd2nroff trurl.md > $(MANUAL)
+
 .PHONY: install
 install:
 	$(INSTALL) -d $(DESTDIR)$(BINDIR)
 	$(INSTALL) -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)
-	$(INSTALL) -d $(DESTDIR)$(MANDIR)
 	(if test -f $(MANUAL); then \
+	$(INSTALL) -d $(DESTDIR)$(MANDIR); \
 	$(INSTALL) -m 0644 $(MANUAL) $(DESTDIR)$(MANDIR); \
+	fi)
+	(if test -f $(COMPLETION_FILES); then \
+	$(INSTALL) -d $(DESTDIR)$(ZSH_COMPLETIONSDIR); \
+	$(INSTALL) -m 0755 $(COMPLETION_FILES) $(ZSH_COMPLETIONSDIR)/_trurl; \
 	fi)
 
 .PHONY: clean
 clean:
-	rm -f $(OBJS) $(TARGET)
+	rm -f $(OBJS) $(TARGET) $(COMPLETION_FILES) $(MANUAL)
 
 .PHONY: test
 test: $(TARGET)
@@ -70,4 +81,8 @@
 
 .PHONY: checksrc
 checksrc:
-	./checksrc.pl trurl.c version.h
+	./scripts/checksrc.pl trurl.c version.h
+
+.PHONY: completions
+completions: trurl.md
+	./scripts/generate_completions.sh $^

=== debian/changelog ===
trurl (0.16.1-2) unstable; urgency=medium

  * debian/patches/fix-tests-for-newer-libcurl.patch: add new patch
    from upstream so tests work with libcurl 8.15 and newer too.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Sat, 19 Jul 2025 13:47:40 +0200

trurl (0.16.1-1) unstable; urgency=medium

  * New upstream version 0.16.1.
  * debian/control: bump Standards-Version to 4.7.2, no changes needed.
  * debian/copyright: update packaging copyright years.
  * debian/patches/fix-manpage-typo.patch: add new patch.
  * debian/watch: point to curl website which has trurl official signed
    release.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Mon, 12 May 2025 17:41:39 -0300

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                libcurl4-gnutls-dev (>= 7.88.1),
                python3
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/curl/trurl
 Vcs-Browser: https://salsa.debian.org/debian/trurl
 Vcs-Git: https://salsa.debian.org/debian/trurl.git

=== debian/tests/control ===
Test-Command: ln -s /usr/bin/trurl trurl; python3 test.py
Depends: @, python3

=== debian/watch ===
version=4
opts=pgpmode=auto \
  https://curl.se/trurl/ dl/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
